from wsgiref.simple_server import make_server

#Basic cookies management
def setcookie(headers, name, value):
    cookie = '%s=%s' % (name, value)
    headers.append(('Set-Cookie', cookie))

def getcookies(environ):
    cookies = {}
    for cookie in environ['HTTP_COOKIE'].split(';'):
        name, value = cookie.split('=')
        cookies[name.strip()] = value.strip()
    return cookies

def delcookie(headers, name):
    headers.append(('Set-Cookie', '%s=;max-age=0' % name))

def hello_world_app(environ, start_response):
    #Our basic routing, only accept requests for / and /index
    if environ['PATH_INFO'] not in ('/', '/index'):
        start_response("404 Not Found", [('Content-type', 'text/plain')])
        return ['Not Found']

    cookies = getcookies(environ)
   
    #Prepare our answer 
    ans = ['Hello,\n']
    ans.append('You cookies are: ')
    ans.append(str(cookies))

    #Prepare our response headers
    headers = [('Content-type', 'text/plain')]

    #Get counter from the current counter cookie or 1
    counter = 1
    if 'counter' in cookies:
        counter = int(cookies['counter']) + 1

    #Each time counter gets higher than 5 we delete it
    if counter > 5:
        delcookie(headers, 'counter')
    else:
        setcookie(headers, 'counter', counter)

    start_response('200 OK', headers)
    return ans

httpd = make_server('', 8000, hello_world_app)
print "Serving on port 8000..."
httpd.serve_forever()

