from wsgiref.simple_server import make_server
import webob

def hello_world_app(environ, start_response):
    request = webob.Request(environ)
    response = webob.Response(content_type='text/plain')

    #Our basic routing, only accept requests for / and /index
    if request.path not in ('/', '/index'):
        response.status = 404
        response.body = 'Not Found'
        return response(environ, start_response)
   
    #Prepare our answer 
    response.body = 'Hello,\nYour cookies are: %s' % request.cookies

    #Get counter from the current counter cookie or 1
    counter = int(request.cookies.get('counter', 0)) + 1

    #Each time counter gets higher than 5 we delete it
    if counter > 5:
        response.delete_cookie('counter')
    else:
        response.set_cookie('counter', str(counter))

    return response(environ, start_response)

httpd = make_server('', 8000, hello_world_app)
print "Serving on port 8000..."
httpd.serve_forever()


